diff --git a/distrib/utils/sysinst/Makefile.inc b/distrib/utils/sysinst/Makefile.inc
index 6353721..19c67d8 100644
--- a/distrib/utils/sysinst/Makefile.inc
+++ b/distrib/utils/sysinst/Makefile.inc
@@ -13,7 +13,7 @@ WARNS=		4
 
 SRCS+=	menu_defs.c msg_defs.c main.c install.c upgrade.c \
 	txtwalk.c run.c factor.c net.c disks.c disks_lfs.c util.c geom.c \
-	label.c target.c md.c sizemultname.c configmenu.c checkrc.c
+	label.c target.c md.c sizemultname.c configmenu.c checkrc.c partman.c
 
 SRCS+=	${MD_OPTIONS:MAOUT2ELF:S/AOUT2ELF/aout2elf.c/}
 SRCS+=	${MENUS_MD:Mmenus.mbr:S/menus.mbr/mbr.c/}
diff --git a/distrib/utils/sysinst/arch/acorn32/md.c b/distrib/utils/sysinst/arch/acorn32/md.c
index efa9de6..96708ff 100644
--- a/distrib/utils/sysinst/arch/acorn32/md.c
+++ b/distrib/utils/sysinst/arch/acorn32/md.c
@@ -66,7 +66,7 @@ md_init_set_status(int flags)
 int
 md_get_info(void)
 {
-	struct pm->disklabel pm->disklabel;
+	struct disklabel disklabel;
 	int fd;
 	char dev_name[100];
 	static unsigned char bb[DEV_BSIZE];
@@ -74,9 +74,9 @@ md_get_info(void)
 	int offset = 0;
 
 	if (strncmp(pm->diskdev, "wd", 2) == 0)
-		disktype = "ST506";
+		pm->disktype = "ST506";
 	else
-		disktype = "SCSI";
+		pm->disktype = "SCSI";
 
 	snprintf(dev_name, 100, "/dev/r%s%c", pm->diskdev, 'a' + getrawpartition());
 
@@ -86,7 +86,7 @@ md_get_info(void)
 		fprintf(stderr, "Can't open %s\n", dev_name);
 		exit(1);
 	}
-	if (ioctl(fd, DIOCGDINFO, &pm->disklabel) == -1) {
+	if (ioctl(fd, DIOCGDINFO, &disklabel) == -1) {
 		endwin();
 		fprintf(stderr, "Can't read disklabel on %s.\n", dev_name);
 		close(fd);
@@ -173,11 +173,11 @@ md_get_info(void)
 	}
 	close(fd);
 
-	pm->dlcyl = pm->disklabel.d_ncylinders;
-	pm->dlhead = pm->disklabel.d_ntracks;
-	pm->dlsec = pm->disklabel.d_nsectors;
-	pm->sectorsize = pm->disklabel.d_secsize;
-	pm->dlcylsize = pm->disklabel.d_secpercyl;
+	pm->dlcyl = disklabel.d_ncylinders;
+	pm->dlhead = disklabel.d_ntracks;
+	pm->dlsec = disklabel.d_nsectors;
+	pm->sectorsize = disklabel.d_secsize;
+	pm->dlcylsize = disklabel.d_secpercyl;
 
 	/*
 	 * Compute whole disk size. Take max of (pm->dlcyl*pm->dlhead*pm->dlsec)
@@ -186,8 +186,8 @@ md_get_info(void)
 	 * in-core RAW_PART size  value, updating the label will fail.)
 	 */
 	pm->dlsize = pm->dlcyl*pm->dlhead*pm->dlsec;
-	if (pm->disklabel.d_secperunit > pm->dlsize)
-		pm->dlsize = pm->disklabel.d_secperunit;
+	if (disklabel.d_secperunit > pm->dlsize)
+		pm->dlsize = disklabel.d_secperunit;
 
 	pm->ptstart = offset;
 /*	endwin();
@@ -199,7 +199,7 @@ md_get_info(void)
 	printf("dlsz=%d\n", pm->dlsize);
 	printf("pstart=%d\n", pm->ptstart);
 	printf("pstart=%d\n", partsize);
-	printf("secpun=%d\n", pm->disklabel.d_secperunit);
+	printf("secpun=%d\n", disklabel.d_secperunit);
 	backtowin();*/
 
 	return 1;
diff --git a/distrib/utils/sysinst/arch/alpha/md.c b/distrib/utils/sysinst/arch/alpha/md.c
index b481739..cd8fb82 100644
--- a/distrib/utils/sysinst/arch/alpha/md.c
+++ b/distrib/utils/sysinst/arch/alpha/md.c
@@ -63,7 +63,7 @@ md_init_set_status(int flags)
 int
 md_get_info(void)
 {
-	struct pm->disklabel pm->disklabel;
+	struct disklabel disklabel;
 	int fd;
 	char dev_name[100];
 
@@ -75,7 +75,7 @@ md_get_info(void)
 		fprintf (stderr, "Can't open %s\n", dev_name);
 		exit(1);
 	}
-	if (ioctl(fd, DIOCGDINFO, &pm->disklabel) == -1) {
+	if (ioctl(fd, DIOCGDINFO, &disklabel) == -1) {
 		endwin();
 		fprintf (stderr, "Can't read disklabel on %s.\n", dev_name);
 		close(fd);
@@ -83,11 +83,11 @@ md_get_info(void)
 	}
 	close(fd);
 
-	pm->dlcyl = pm->disklabel.d_ncylinders;
-	pm->dlhead = pm->disklabel.d_ntracks;
-	pm->dlsec = pm->disklabel.d_nsectors;
-	pm->sectorsize = pm->disklabel.d_secsize;
-	pm->dlcylsize = pm->disklabel.d_secpercyl;
+	pm->dlcyl = disklabel.d_ncylinders;
+	pm->dlhead = disklabel.d_ntracks;
+	pm->dlsec = disklabel.d_nsectors;
+	pm->sectorsize = disklabel.d_secsize;
+	pm->dlcylsize = disklabel.d_secpercyl;
 
 	/*
 	 * Compute whole disk size. Take max of (pm->dlcyl*pm->dlhead*pm->dlsec)
@@ -96,8 +96,8 @@ md_get_info(void)
 	 * in-core RAW_PART size  value, updating the label will fail.)
 	 */
 	pm->dlsize = pm->dlcyl*pm->dlhead*pm->dlsec;
-	if (pm->disklabel.d_secperunit > pm->dlsize)
-		pm->dlsize = pm->disklabel.d_secperunit;
+	if (disklabel.d_secperunit > pm->dlsize)
+		pm->dlsize = disklabel.d_secperunit;
 
 	return 1;
 }
diff --git a/distrib/utils/sysinst/arch/amd64/md.h b/distrib/utils/sysinst/arch/amd64/md.h
index e5ce41d..6f4325e 100644
--- a/distrib/utils/sysinst/arch/amd64/md.h
+++ b/distrib/utils/sysinst/arch/amd64/md.h
@@ -89,7 +89,7 @@
  * On amd64, we allow "wd"  ST-506/IDE disks,  "sd" scsi disks, "ld" logical
  * disks and "raid" raidframe disks.
  */
-#define DISK_NAMES "wd", "sd", "ld", "raid:pm->no_mbr", "xbd:pm->no_mbr"
+#define DISK_NAMES "wd", "sd", "ld", "raid:no_mbr", "xbd:no_mbr"
 
 /*
  * Machine-specific command to write a new label to a disk.
diff --git a/distrib/utils/sysinst/arch/arc/md.c b/distrib/utils/sysinst/arch/arc/md.c
index e0a93c4..0363ef9 100644
--- a/distrib/utils/sysinst/arch/arc/md.c
+++ b/distrib/utils/sysinst/arch/arc/md.c
@@ -159,7 +159,7 @@ md_make_bsd_partitions(void)
 		p = &pm->oldlabel[i];
 		if (p->pi_fstype == FS_UNUSED || p->pi_size == 0)
 			continue;
-		if (layoutkind == 4) {
+		if (layoutkind == LY_USEEXIST) {
 			if (PI_ISBSDFS(p))
 				p->pi_flags |= PIF_MOUNT;
 		} else {
@@ -173,7 +173,7 @@ md_make_bsd_partitions(void)
 		pm->bsdlabel[i] = pm->oldlabel[i];
 	 }
 
-	if (layoutkind == 4) {
+	if (layoutkind == LY_USEEXIST) {
 		/* XXX Check we have a sensible layout */
 		;
 	} else
diff --git a/distrib/utils/sysinst/arch/atari/md.c b/distrib/utils/sysinst/arch/atari/md.c
index 59aaacc..4c2ab3d 100644
--- a/distrib/utils/sysinst/arch/atari/md.c
+++ b/distrib/utils/sysinst/arch/atari/md.c
@@ -80,9 +80,9 @@ md_make_bsd_partitions(void)
 	 * Setup the disktype so /etc/disktab gets proper info
 	 */
 	if (strncmp (pm->diskdev, "sd", 2) == 0)
-		disktype = "SCSI";
+		pm->disktype = "SCSI";
 	else
-		disktype = "ST506";
+		pm->disktype = "ST506";
 
 	return 1;
 }
diff --git a/distrib/utils/sysinst/arch/cats/md.c b/distrib/utils/sysinst/arch/cats/md.c
index e799339..6ac23d6 100644
--- a/distrib/utils/sysinst/arch/cats/md.c
+++ b/distrib/utils/sysinst/arch/cats/md.c
@@ -63,7 +63,7 @@ md_init_set_status(int flags)
 int
 md_get_info(void)
 {
-	struct pm->disklabel pm->disklabel;
+	struct disklabel disklabel;
 	int fd;
 	char dev_name[100];
 #if 0
@@ -73,9 +73,9 @@ md_get_info(void)
 	int offset = 0;
 
 	if (strncmp(pm->diskdev, "wd", 2) == 0)
-		disktype = "ST506";
+		pm->disktype = "ST506";
 	else
-		disktype = "SCSI";
+		pm->disktype = "SCSI";
 
 	snprintf(dev_name, 100, "/dev/r%sc", pm->diskdev);
 
@@ -85,7 +85,7 @@ md_get_info(void)
 		fprintf(stderr, "Can't open %s\n", dev_name);
 		exit(1);
 	}
-	if (ioctl(fd, DIOCGDINFO, &pm->disklabel) == -1) {
+	if (ioctl(fd, DIOCGDINFO, &disklabel) == -1) {
 		endwin();
 		fprintf(stderr, "Can't read disklabel on %s.\n", dev_name);
 		close(fd);
@@ -94,11 +94,11 @@ md_get_info(void)
 
 	close(fd);
 
-	pm->dlcyl = pm->disklabel.d_ncylinders;
-	pm->dlhead = pm->disklabel.d_ntracks;
-	pm->dlsec = pm->disklabel.d_nsectors;
-	pm->sectorsize = pm->disklabel.d_secsize;
-	pm->dlcylsize = pm->disklabel.d_secpercyl;
+	pm->dlcyl = disklabel.d_ncylinders;
+	pm->dlhead = disklabel.d_ntracks;
+	pm->dlsec = disklabel.d_nsectors;
+	pm->sectorsize = disklabel.d_secsize;
+	pm->dlcylsize = disklabel.d_secpercyl;
 
 	/*
 	 * Compute whole disk size. Take max of (pm->dlcyl*pm->dlhead*pm->dlsec)
@@ -107,8 +107,8 @@ md_get_info(void)
 	 * in-core RAW_PART size  value, updating the label will fail.)
 	 */
 	pm->dlsize = pm->dlcyl*pm->dlhead*pm->dlsec;
-	if (pm->disklabel.d_secperunit > pm->dlsize)
-		pm->dlsize = pm->disklabel.d_secperunit;
+	if (disklabel.d_secperunit > pm->dlsize)
+		pm->dlsize = disklabel.d_secperunit;
 
 	pm->ptstart = offset;
 /*	endwin();
@@ -120,7 +120,7 @@ md_get_info(void)
 	printf("dlsz=%d\n", pm->dlsize);
 	printf("pstart=%d\n", pm->ptstart);
 	printf("pstart=%d\n", partsize);
-	printf("secpun=%d\n", pm->disklabel.d_secperunit);
+	printf("secpun=%d\n", disklabel.d_secperunit);
 	backtowin();*/
 
 	return 1;
diff --git a/distrib/utils/sysinst/arch/cobalt/md.c b/distrib/utils/sysinst/arch/cobalt/md.c
index 1826669..a96053f 100644
--- a/distrib/utils/sysinst/arch/cobalt/md.c
+++ b/distrib/utils/sysinst/arch/cobalt/md.c
@@ -160,7 +160,7 @@ md_make_bsd_partitions(void)
 		p = &pm->oldlabel[i];
 		if (p->pi_fstype == FS_UNUSED || p->pi_size == 0)
 			continue;
-		if (layoutkind == 4) {
+		if (layoutkind == LY_USEEXIST) {
 			if (PI_ISBSDFS(p))
 				p->pi_flags |= PIF_MOUNT;
 		} else {
@@ -174,7 +174,7 @@ md_make_bsd_partitions(void)
 		pm->bsdlabel[i] = pm->oldlabel[i];
 	 }
 
-	if (layoutkind == 4) {
+	if (layoutkind == LY_USEEXIST) {
 		/* XXX Check we have a sensible layout */
 		;
 	} else
diff --git a/distrib/utils/sysinst/arch/emips/md.c b/distrib/utils/sysinst/arch/emips/md.c
index fc6a514..30e46e9 100644
--- a/distrib/utils/sysinst/arch/emips/md.c
+++ b/distrib/utils/sysinst/arch/emips/md.c
@@ -62,7 +62,7 @@ md_init_set_status(int flags)
 int
 md_get_info(void)
 {
-	struct pm->disklabel pm->disklabel;
+	struct disklabel disklabel;
 	int fd;
 	char dev_name[100];
 
@@ -76,7 +76,7 @@ md_get_info(void)
 		fprintf(stderr, "Can't open %s\n", dev_name);
 		exit(1);
 	}
-	if (ioctl(fd, DIOCGDINFO, &pm->disklabel) == -1) {
+	if (ioctl(fd, DIOCGDINFO, &disklabel) == -1) {
 		if (logfp)
 			(void)fprintf(logfp, "Can't read disklabel on %s.\n",
 				dev_name);
@@ -87,11 +87,11 @@ md_get_info(void)
 	}
 	close(fd);
 
-	pm->dlcyl = pm->disklabel.d_ncylinders;
-	pm->dlhead = pm->disklabel.d_ntracks;
-	pm->dlsec = pm->disklabel.d_nsectors;
-	pm->sectorsize = pm->disklabel.d_secsize;
-	pm->dlcylsize = pm->disklabel.d_secpercyl;
+	pm->dlcyl = disklabel.d_ncylinders;
+	pm->dlhead = disklabel.d_ntracks;
+	pm->dlsec = disklabel.d_nsectors;
+	pm->sectorsize = disklabel.d_secsize;
+	pm->dlcylsize = disklabel.d_secpercyl;
 
 	/*
 	 * Compute whole disk size. Take max of (pm->dlcyl*pm->dlhead*pm->dlsec)
@@ -100,8 +100,8 @@ md_get_info(void)
 	 * in-core RAW_PART size  value, updating the label will fail.)
 	 */
 	pm->dlsize = pm->dlcyl*pm->dlhead*pm->dlsec;
-	if (pm->disklabel.d_secperunit > pm->dlsize)
-		pm->dlsize = pm->disklabel.d_secperunit;
+	if (disklabel.d_secperunit > pm->dlsize)
+		pm->dlsize = disklabel.d_secperunit;
 
 	return 1;
 }
diff --git a/distrib/utils/sysinst/arch/evbarm/md.c b/distrib/utils/sysinst/arch/evbarm/md.c
index f381f46..2a7b53f 100644
--- a/distrib/utils/sysinst/arch/evbarm/md.c
+++ b/distrib/utils/sysinst/arch/evbarm/md.c
@@ -63,7 +63,7 @@ md_init_set_status(int flags)
 int
 md_get_info(void)
 {
-	struct pm->disklabel pm->disklabel;
+	struct disklabel disklabel;
 	int fd;
 	char dev_name[100];
 
@@ -77,9 +77,9 @@ md_get_info(void)
 		return 0;
 
 	if (strncmp(pm->diskdev, "wd", 2) == 0)
-		disktype = "ST506";
+		pm->disktype = "ST506";
 	else
-		disktype = "SCSI";
+		pm->disktype = "SCSI";
 
 	snprintf(dev_name, 100, "/dev/r%sc", pm->diskdev);
 
@@ -89,7 +89,7 @@ md_get_info(void)
 		fprintf(stderr, "Can't open %s\n", dev_name);
 		exit(1);
 	}
-	if (ioctl(fd, DIOCGDINFO, &pm->disklabel) == -1) {
+	if (ioctl(fd, DIOCGDINFO, &disklabel) == -1) {
 		endwin();
 		fprintf(stderr, "Can't read disklabel on %s.\n", dev_name);
 		close(fd);
@@ -97,11 +97,11 @@ md_get_info(void)
 	}
 	close(fd);
 
-	pm->dlcyl = pm->disklabel.d_ncylinders;
-	pm->dlhead = pm->disklabel.d_ntracks;
-	pm->dlsec = pm->disklabel.d_nsectors;
-	pm->sectorsize = pm->disklabel.d_secsize;
-	pm->dlcylsize = pm->disklabel.d_secpercyl;
+	pm->dlcyl = disklabel.d_ncylinders;
+	pm->dlhead = disklabel.d_ntracks;
+	pm->dlsec = disklabel.d_nsectors;
+	pm->sectorsize = disklabel.d_secsize;
+	pm->dlcylsize = disklabel.d_secpercyl;
 
 	/*
 	 * Compute whole disk size. Take max of (pm->dlcyl*pm->dlhead*pm->dlsec)
@@ -110,8 +110,8 @@ md_get_info(void)
 	 * in-core RAW_PART size  value, updating the label will fail.)
 	 */
 	pm->dlsize = pm->dlcyl*pm->dlhead*pm->dlsec;
-	if (pm->disklabel.d_secperunit > pm->dlsize)
-		pm->dlsize = pm->disklabel.d_secperunit;
+	if (disklabel.d_secperunit > pm->dlsize)
+		pm->dlsize = disklabel.d_secperunit;
 
 	return 1;
 }
diff --git a/distrib/utils/sysinst/arch/evbppc/md.c b/distrib/utils/sysinst/arch/evbppc/md.c
index b60eb35..f311431 100644
--- a/distrib/utils/sysinst/arch/evbppc/md.c
+++ b/distrib/utils/sysinst/arch/evbppc/md.c
@@ -103,7 +103,7 @@ int
 md_post_disklabel(void)
 {
 	/* Sector forwarding / badblocks ... */
-	if (*doessf) {
+	if (*pm->doessf) {
 		printf ("%s", msg_string (MSG_dobad144));
 		return run_program(RUN_DISPLAY, "/usr/sbin/bad144 %s 0",
 		    pm->diskdev);
diff --git a/distrib/utils/sysinst/arch/evbsh3/md.c b/distrib/utils/sysinst/arch/evbsh3/md.c
index d858a3c..76df729 100644
--- a/distrib/utils/sysinst/arch/evbsh3/md.c
+++ b/distrib/utils/sysinst/arch/evbsh3/md.c
@@ -51,7 +51,7 @@
 int
 md_get_info(void)
 {
-	struct pm->disklabel pm->disklabel;
+	struct disklabel disklabel;
 	int fd;
 	char dev_name[100];
 
@@ -63,7 +63,7 @@ md_get_info(void)
 		fprintf (stderr, "Can't open %s\n", dev_name);
 		exit(1);
 	}
-	if (ioctl(fd, DIOCGDINFO, &pm->disklabel) == -1) {
+	if (ioctl(fd, DIOCGDINFO, &disklabel) == -1) {
 		endwin();
 		fprintf (stderr, "Can't read disklabel on %s.\n", dev_name);
 		close(fd);
@@ -71,11 +71,11 @@ md_get_info(void)
 	}
 	close(fd);
 
-	pm->dlcyl = pm->disklabel.d_ncylinders;
-	pm->dlhead = pm->disklabel.d_ntracks;
-	pm->dlsec = pm->disklabel.d_nsectors;
-	pm->sectorsize = pm->disklabel.d_secsize;
-	pm->dlcylsize = pm->disklabel.d_secpercyl;
+	pm->dlcyl = disklabel.d_ncylinders;
+	pm->dlhead = disklabel.d_ntracks;
+	pm->dlsec = disklabel.d_nsectors;
+	pm->sectorsize = disklabel.d_secsize;
+	pm->dlcylsize = disklabel.d_secpercyl;
 
 	/*
 	 * Compute whole disk size. Take max of (pm->dlcyl*pm->dlhead*pm->dlsec)
@@ -84,8 +84,8 @@ md_get_info(void)
 	 * in-core RAW_PART size  value, updating the label will fail.)
 	 */
 	pm->dlsize = pm->dlcyl * pm->dlhead * pm->dlsec;
-	if (pm->disklabel.d_secperunit > pm->dlsize)
-		pm->dlsize = pm->disklabel.d_secperunit;
+	if (disklabel.d_secperunit > pm->dlsize)
+		pm->dlsize = disklabel.d_secperunit;
 
 	return 1;
 }
diff --git a/distrib/utils/sysinst/arch/evbsh3/md.h b/distrib/utils/sysinst/arch/evbsh3/md.h
index 9c8947a..7182e72 100644
--- a/distrib/utils/sysinst/arch/evbsh3/md.h
+++ b/distrib/utils/sysinst/arch/evbsh3/md.h
@@ -36,7 +36,7 @@
 /*
  * Symbolic names for disk partitions
  */
-#include <machine/pm->disklabel.h>
+#include <machine/disklabel.h>
 
 #define	PART_ROOT	PART_A
 #define	PART_SWAP	PART_B
diff --git a/distrib/utils/sysinst/arch/ews4800mips/md.c b/distrib/utils/sysinst/arch/ews4800mips/md.c
index a77bb43..925dde8 100644
--- a/distrib/utils/sysinst/arch/ews4800mips/md.c
+++ b/distrib/utils/sysinst/arch/ews4800mips/md.c
@@ -65,7 +65,7 @@ md_init_set_status(int flags)
 int
 md_get_info(void)
 {
-	struct pm->disklabel pm->disklabel;
+	struct disklabel disklabel;
 	int fd;
 	char dev_name[100];
 
@@ -77,7 +77,7 @@ md_get_info(void)
 		fprintf (stderr, "Can't open %s\n", dev_name);
 		exit(1);
 	}
-	if (ioctl(fd, DIOCGDINFO, &pm->disklabel) == -1) {
+	if (ioctl(fd, DIOCGDINFO, &disklabel) == -1) {
 		endwin();
 		fprintf (stderr, "Can't read disklabel on %s.\n", dev_name);
 		close(fd);
@@ -85,11 +85,11 @@ md_get_info(void)
 	}
 	close(fd);
 
-	pm->dlcyl = pm->disklabel.d_ncylinders;
-	pm->dlhead = pm->disklabel.d_ntracks;
-	pm->dlsec = pm->disklabel.d_nsectors;
-	pm->sectorsize = pm->disklabel.d_secsize;
-	pm->dlcylsize = pm->disklabel.d_secpercyl;
+	pm->dlcyl = disklabel.d_ncylinders;
+	pm->dlhead = disklabel.d_ntracks;
+	pm->dlsec = disklabel.d_nsectors;
+	pm->sectorsize = disklabel.d_secsize;
+	pm->dlcylsize = disklabel.d_secpercyl;
 
 	/*
 	 * Compute whole disk size. Take max of (pm->dlcyl*pm->dlhead*pm->dlsec)
@@ -98,8 +98,8 @@ md_get_info(void)
 	 * in-core RAW_PART size  value, updating the label will fail.)
 	 */
 	pm->dlsize = pm->dlcyl * pm->dlhead * pm->dlsec;
-	if (pm->disklabel.d_secperunit > pm->dlsize)
-		pm->dlsize = pm->disklabel.d_secperunit;
+	if (disklabel.d_secperunit > pm->dlsize)
+		pm->dlsize = disklabel.d_secperunit;
 
 	return 1;
 }
diff --git a/distrib/utils/sysinst/arch/hp300/md.c b/distrib/utils/sysinst/arch/hp300/md.c
index ff3d6c6..e58dc39 100644
--- a/distrib/utils/sysinst/arch/hp300/md.c
+++ b/distrib/utils/sysinst/arch/hp300/md.c
@@ -64,7 +64,7 @@ md_get_info(void)
 	char buf[1024];
 	int fd;
 	char dev_name[100];
-	struct pm->disklabel pm->disklabel;
+	struct disklabel disklabel;
 
 	snprintf(dev_name, sizeof(dev_name), "/dev/r%sc", pm->diskdev);
 
@@ -76,7 +76,7 @@ md_get_info(void)
 		fprintf(stderr, "Can't open %s\n", dev_name);
 		exit(1);
 	}
-	if (ioctl(fd, DIOCGDINFO, &pm->disklabel) == -1) {
+	if (ioctl(fd, DIOCGDINFO, &disklabel) == -1) {
 		if (logfp)
 			(void)fprintf(logfp, "Can't read disklabel on %s.\n",
 				dev_name);
@@ -85,18 +85,18 @@ md_get_info(void)
 		close(fd);
 		exit(1);
 	}
-	if (pm->disklabel.d_secsize != 512) {
+	if (disklabel.d_secsize != 512) {
 		endwin();
 		fprintf(stderr, "Non-512byte/sector disk is not supported.\n");
 		close(fd);
 		exit(1);
 	}
 
-	pm->dlcyl = pm->disklabel.d_ncylinders;
-	pm->dlhead = pm->disklabel.d_ntracks;
-	pm->dlsec = pm->disklabel.d_nsectors;
-	pm->sectorsize = pm->disklabel.d_secsize;
-	pm->dlcylsize = pm->disklabel.d_secpercyl;
+	pm->dlcyl = disklabel.d_ncylinders;
+	pm->dlhead = disklabel.d_ntracks;
+	pm->dlsec = disklabel.d_nsectors;
+	pm->sectorsize = disklabel.d_secsize;
+	pm->dlcylsize = disklabel.d_secpercyl;
 	pm->dlsize = pm->dlcyl*pm->dlhead*pm->dlsec;
 
 	if (read(fd, buf, 1024) < 0) {
diff --git a/distrib/utils/sysinst/arch/hp700/md.c b/distrib/utils/sysinst/arch/hp700/md.c
index 17ebd2e..229729c 100644
--- a/distrib/utils/sysinst/arch/hp700/md.c
+++ b/distrib/utils/sysinst/arch/hp700/md.c
@@ -66,7 +66,7 @@ md_init_set_status(int flags)
 int
 md_get_info(void)
 {
-	struct pm->disklabel pm->disklabel;
+	struct disklabel disklabel;
 	int fd;
 	char dev_name[100];
 
@@ -80,7 +80,7 @@ md_get_info(void)
 		fprintf(stderr, "Can't open %s\n", dev_name);
 		exit(1);
 	}
-	if (ioctl(fd, DIOCGDINFO, &pm->disklabel) == -1) {
+	if (ioctl(fd, DIOCGDINFO, &disklabel) == -1) {
 		if (logfp)
 			(void)fprintf(logfp, "Can't read disklabel on %s.\n",
 				dev_name);
@@ -91,11 +91,11 @@ md_get_info(void)
 	}
 	close(fd);
 
-	pm->dlcyl = pm->disklabel.d_ncylinders;
-	pm->dlhead = pm->disklabel.d_ntracks;
-	pm->dlsec = pm->disklabel.d_nsectors;
-	pm->sectorsize = pm->disklabel.d_secsize;
-	pm->dlcylsize = pm->disklabel.d_secpercyl;
+	pm->dlcyl = disklabel.d_ncylinders;
+	pm->dlhead = disklabel.d_ntracks;
+	pm->dlsec = disklabel.d_nsectors;
+	pm->sectorsize = disklabel.d_secsize;
+	pm->dlcylsize = disklabel.d_secpercyl;
 
 	/*
 	 * Compute whole disk size. Take max of (pm->dlcyl*pm->dlhead*pm->dlsec)
@@ -104,8 +104,8 @@ md_get_info(void)
 	 * in-core RAW_PART size  value, updating the label will fail.)
 	 */
 	pm->dlsize = pm->dlcyl*pm->dlhead*pm->dlsec;
-	if (pm->disklabel.d_secperunit > pm->dlsize)
-		pm->dlsize = pm->disklabel.d_secperunit;
+	if (disklabel.d_secperunit > pm->dlsize)
+		pm->dlsize = disklabel.d_secperunit;
 
 	/*
 	 * hp700 PDC can only address up to 2GB.
diff --git a/distrib/utils/sysinst/arch/hpcarm/md.c b/distrib/utils/sysinst/arch/hpcarm/md.c
index 628a48c..4820214 100644
--- a/distrib/utils/sysinst/arch/hpcarm/md.c
+++ b/distrib/utils/sysinst/arch/hpcarm/md.c
@@ -132,7 +132,7 @@ int
 md_post_disklabel(void)
 {
 	/* Sector forwarding / badblocks ... */
-	if (*doessf) {
+	if (*pm->doessf) {
 		msg_display(MSG_dobad144);
 		return run_program(RUN_DISPLAY, "/usr/sbin/bad144 %s 0",
 		    pm->diskdev);
diff --git a/distrib/utils/sysinst/arch/hpcmips/md.c b/distrib/utils/sysinst/arch/hpcmips/md.c
index cbdd705..47eee83 100644
--- a/distrib/utils/sysinst/arch/hpcmips/md.c
+++ b/distrib/utils/sysinst/arch/hpcmips/md.c
@@ -106,7 +106,7 @@ int
 md_post_disklabel(void)
 {
 	/* Sector forwarding / badblocks ... */
-	if (*doessf) {
+	if (*pm->doessf) {
 		msg_display(MSG_dobad144);
 		return run_program(RUN_DISPLAY, "/usr/sbin/bad144 %s 0",
 		    pm->diskdev);
diff --git a/distrib/utils/sysinst/arch/i386/md.c b/distrib/utils/sysinst/arch/i386/md.c
index 4b51cb90..bed7e5e 100644
--- a/distrib/utils/sysinst/arch/i386/md.c
+++ b/distrib/utils/sysinst/arch/i386/md.c
@@ -341,7 +341,7 @@ md_post_newfs(void)
 	/* Copy bootstrap in by hand - /sbin/installboot explodes ramdisks */
 	ret = 1;
 
-	snprintf(bootxx, sizeof bootxx, "/dev/r%s%c", pm->diskdev, 'a' + rootpart);
+	snprintf(bootxx, sizeof bootxx, "/dev/r%s%c", pm->diskdev, 'a' + pm->rootpart);
 	td = open(bootxx, O_RDWR, 0);
 	bootxx_filename = bootxx_name();
 	if (bootxx_filename != NULL) {
diff --git a/distrib/utils/sysinst/arch/i386/md.h b/distrib/utils/sysinst/arch/i386/md.h
index ee1adfa..d99f4e3 100644
--- a/distrib/utils/sysinst/arch/i386/md.h
+++ b/distrib/utils/sysinst/arch/i386/md.h
@@ -84,7 +84,7 @@
  * On i386, we allow "wd"  ST-506/IDE disks,  "sd" scsi disks, "ld" logical
  * disks, "ed" IBM ESDI disks, "raid" raidframe disks
  */
-#define DISK_NAMES "wd", "sd", "ld", "ed", "raid:pm->no_mbr", "xbd:pm->no_mbr"
+#define DISK_NAMES "wd", "sd", "ld", "ed", "raid:no_mbr", "xbd:no_mbr"
 
 /*
  * Machine-specific command to write a new label to a disk.
diff --git a/distrib/utils/sysinst/arch/luna68k/md.c b/distrib/utils/sysinst/arch/luna68k/md.c
index 7e52b20..b27b69f 100644
--- a/distrib/utils/sysinst/arch/luna68k/md.c
+++ b/distrib/utils/sysinst/arch/luna68k/md.c
@@ -64,7 +64,7 @@ md_init_set_status(int flags)
 int
 md_get_info(void)
 {
-	struct pm->disklabel pm->disklabel;
+	struct disklabel disklabel;
 	int fd;
 	char dev_name[100];
 
@@ -76,7 +76,7 @@ md_get_info(void)
 		fprintf (stderr, "Can't open %s\n", dev_name);
 		exit(1);
 	}
-	if (ioctl(fd, DIOCGDINFO, &pm->disklabel) == -1) {
+	if (ioctl(fd, DIOCGDINFO, &disklabel) == -1) {
 		endwin();
 		fprintf (stderr, "Can't read disklabel on %s.\n", dev_name);
 		close(fd);
@@ -84,11 +84,11 @@ md_get_info(void)
 	}
 	close(fd);
 
-	pm->dlcyl = pm->disklabel.d_ncylinders;
-	pm->dlhead = pm->disklabel.d_ntracks;
-	pm->dlsec = pm->disklabel.d_nsectors;
-	pm->sectorsize = pm->disklabel.d_secsize;
-	pm->dlcylsize = pm->disklabel.d_secpercyl;
+	pm->dlcyl = disklabel.d_ncylinders;
+	pm->dlhead = disklabel.d_ntracks;
+	pm->dlsec = disklabel.d_nsectors;
+	pm->sectorsize = disklabel.d_secsize;
+	pm->dlcylsize = disklabel.d_secpercyl;
 
 	/*
 	 * Compute whole disk size. Take max of (pm->dlcyl*pm->dlhead*pm->dlsec)
@@ -97,8 +97,8 @@ md_get_info(void)
 	 * in-core RAW_PART size  value, updating the label will fail.)
 	 */
 	pm->dlsize = pm->dlcyl * pm->dlhead * pm->dlsec;
-	if (pm->disklabel.d_secperunit > pm->dlsize)
-		pm->dlsize = pm->disklabel.d_secperunit;
+	if (disklabel.d_secperunit > pm->dlsize)
+		pm->dlsize = disklabel.d_secperunit;
 
 	return 1;
 }
diff --git a/distrib/utils/sysinst/arch/mac68k/md.c b/distrib/utils/sysinst/arch/mac68k/md.c
index 20119eb..c2ad149 100644
--- a/distrib/utils/sysinst/arch/mac68k/md.c
+++ b/distrib/utils/sysinst/arch/mac68k/md.c
@@ -134,7 +134,7 @@ md_init_set_status(int flags)
 int
 md_get_info(void)
 {
-	struct pm->disklabel pm->disklabel;
+	struct disklabel disklabel;
 	int fd, i;
 	char dev_name[100];
 	struct apple_part_map_entry block;
@@ -154,7 +154,7 @@ md_get_info(void)
 	/*
 	 * Try to get the default disklabel info for the device
 	 */
-	if (ioctl(fd, DIOCGDINFO, &pm->disklabel) == -1) {
+	if (ioctl(fd, DIOCGDINFO, &disklabel) == -1) {
 		endwin();
 		fprintf (stderr, "Can't read disklabel on %s\n", dev_name);
 		close(fd);
@@ -164,15 +164,15 @@ md_get_info(void)
 	 * Get the disk parameters from the disk driver.  It should have
 	 *  obained them by querying the disk itself.
 	 */
-	blk_size = pm->disklabel.d_secsize;
-	pm->dlcyl = pm->disklabel.d_ncylinders;
-	pm->dlhead = pm->disklabel.d_ntracks;
-	pm->dlsec = pm->disklabel.d_nsectors;
+	blk_size = disklabel.d_secsize;
+	pm->dlcyl = disklabel.d_ncylinders;
+	pm->dlhead = disklabel.d_ntracks;
+	pm->dlsec = disklabel.d_nsectors;
 	/*
 	 * Just in case, initialize the structures we'll need if we
 	 *  need to completely initialize the disk.
 	 */
-	pm->dlsize = pm->disklabel.d_secperunit;
+	pm->dlsize = disklabel.d_secperunit;
 	for (i=0;i<NEW_MAP_SIZE;i++) {
 	   if (i > 0)
 		new_map[i].pmPyPartStart = new_map[i-1].pmPyPartStart +
@@ -185,7 +185,7 @@ md_get_info(void)
 	   }
 	   pm->dlsize -= new_map[i].pmPartBlkCnt;
 	}
-	pm->dlsize = pm->disklabel.d_secperunit;
+	pm->dlsize = disklabel.d_secperunit;
 #if 0
 	msg_display(MSG_dldebug, blk_size, pm->dlcyl, pm->dlhead, pm->dlsec, pm->dlsize);
 	process_menu(MENU_ok, NULL);
@@ -224,10 +224,10 @@ md_get_info(void)
 	 * Setup the disktype so /etc/disktab gets proper info
 	 */
 	if (strncmp(pm->diskdev, "sd", 2) == 0) {
-		disktype = "SCSI";
-		doessf = "sf:";
+		pm->disktype = "SCSI";
+		pm->doessf = "sf:";
 	} else
-		disktype = "IDE";
+		pm->disktype = "IDE";
 
 	return edit_diskmap();
 }
@@ -270,7 +270,7 @@ md_make_bsd_partitions(void)
 	pm->bsdlabel[RAW_PART].pi_size = pm->dlsize;
 	/*
 	 * Now, scan through the Disk Partition Map and transfer the
-	 *  information into the incore pm->disklabel.
+	 *  information into the incore disklabel.
 	 */
 	for (i=0;i<map.usable_cnt;i++) {
 	    j = map.mblk[i];
@@ -322,10 +322,10 @@ md_make_bsd_partitions(void)
 		exit (1);
 	}
 	(void)fprintf (f, "%s|NetBSD installation generated:\\\n", pm->bsddiskname);
-	(void)fprintf (f, "\t:dt=%s:ty=winchester:\\\n", disktype);
+	(void)fprintf (f, "\t:dt=%s:ty=winchester:\\\n", pm->disktype);
 	(void)fprintf (f, "\t:nc#%d:nt#%d:ns#%d:\\\n", pm->dlcyl, pm->dlhead, pm->dlsec);
 	(void)fprintf (f, "\t:sc#%d:su#%" PRIu32 ":\\\n", pm->dlhead*pm->dlsec, (uint32_t)pm->dlsize);
-	(void)fprintf (f, "\t:se#%d:%s\\\n", blk_size, doessf);
+	(void)fprintf (f, "\t:se#%d:%s\\\n", blk_size, pm->doessf);
 	for (i=0; i<8; i++) {
 		if (pm->bsdlabel[i].pi_fstype == FS_HFS)
 		    (void)fprintf (f, "\t:p%c#%d:o%c#%d:t%c=macos:",
@@ -369,7 +369,7 @@ md_pre_disklabel(void)
 {
     int fd;
     char dev_name[100];
-    struct pm->disklabel lp;
+    struct disklabel lp;
     Block0 new_block0 = {APPLE_DRVR_MAP_MAGIC, 512,
 	 		 0, 0, 0, 0, 0, 0, 0, 0, {0}};
 
@@ -457,7 +457,7 @@ md_pre_disklabel(void)
 int
 md_post_disklabel(void)
 {
-    struct pm->disklabel updated_label;
+    struct disklabel updated_label;
     int fd, i, no_match;
     char dev_name[100], buf[80];
     const char *fst[] = {"free", "swap", " v6 ", " v7 ", "sysv", "v71k",
diff --git a/distrib/utils/sysinst/arch/macppc/md.c b/distrib/utils/sysinst/arch/macppc/md.c
index ff9c6e7..d9138ea 100644
--- a/distrib/utils/sysinst/arch/macppc/md.c
+++ b/distrib/utils/sysinst/arch/macppc/md.c
@@ -63,7 +63,7 @@ md_init_set_status(int flags)
 int
 md_get_info(void)
 {
-	struct pm->disklabel pm->disklabel;
+	struct disklabel disklabel;
 	int fd;
 	char dev_name[100];
 
@@ -75,7 +75,7 @@ md_get_info(void)
 		fprintf (stderr, "Can't open %s\n", dev_name);
 		exit(1);
 	}
-	if (ioctl(fd, DIOCGDINFO, &pm->disklabel) == -1) {
+	if (ioctl(fd, DIOCGDINFO, &disklabel) == -1) {
 		endwin();
 		fprintf (stderr, "Can't read disklabel on %s.\n", dev_name);
 		close(fd);
@@ -83,11 +83,11 @@ md_get_info(void)
 	}
 	close(fd);
 
-	pm->dlcyl = pm->disklabel.d_ncylinders;
-	pm->dlhead = pm->disklabel.d_ntracks;
-	pm->dlsec = pm->disklabel.d_nsectors;
-	pm->sectorsize = pm->disklabel.d_secsize;
-	pm->dlcylsize = pm->disklabel.d_secpercyl;
+	pm->dlcyl = disklabel.d_ncylinders;
+	pm->dlhead = disklabel.d_ntracks;
+	pm->dlsec = disklabel.d_nsectors;
+	pm->sectorsize = disklabel.d_secsize;
+	pm->dlcylsize = disklabel.d_secpercyl;
 
 	/*
 	 * Compute whole disk size. Take max of (pm->dlcyl*pm->dlhead*pm->dlsec)
@@ -96,8 +96,8 @@ md_get_info(void)
 	 * in-core RAW_PART size  value, updating the label will fail.)
 	 */
 	pm->dlsize = pm->dlcyl*pm->dlhead*pm->dlsec;
-	if (pm->disklabel.d_secperunit > pm->dlsize)
-		pm->dlsize = pm->disklabel.d_secperunit;
+	if (disklabel.d_secperunit > pm->dlsize)
+		pm->dlsize = disklabel.d_secperunit;
 
 	return 1;
 }
diff --git a/distrib/utils/sysinst/arch/mipsco/md.c b/distrib/utils/sysinst/arch/mipsco/md.c
index 7f2db6a..5722452 100644
--- a/distrib/utils/sysinst/arch/mipsco/md.c
+++ b/distrib/utils/sysinst/arch/mipsco/md.c
@@ -63,7 +63,7 @@ md_init_set_status(int flags)
 int
 md_get_info(void)
 {
-	struct pm->disklabel pm->disklabel;
+	struct disklabel disklabel;
 	int fd;
 	char dev_name[100];
 
@@ -77,7 +77,7 @@ md_get_info(void)
 		fprintf(stderr, "Can't open %s\n", dev_name);
 		exit(1);
 	}
-	if (ioctl(fd, DIOCGDINFO, &pm->disklabel) == -1) {
+	if (ioctl(fd, DIOCGDINFO, &disklabel) == -1) {
 		if (logfp)
 			(void)fprintf(logfp, "Can't read disklabel on %s.\n",
 				dev_name);
@@ -88,11 +88,11 @@ md_get_info(void)
 	}
 	close(fd);
 
-	pm->dlcyl = pm->disklabel.d_ncylinders;
-	pm->dlhead = pm->disklabel.d_ntracks;
-	pm->dlsec = pm->disklabel.d_nsectors;
-	pm->sectorsize = pm->disklabel.d_secsize;
-	pm->dlcylsize = pm->disklabel.d_secpercyl;
+	pm->dlcyl = disklabel.d_ncylinders;
+	pm->dlhead = disklabel.d_ntracks;
+	pm->dlsec = disklabel.d_nsectors;
+	pm->sectorsize = disklabel.d_secsize;
+	pm->dlcylsize = disklabel.d_secpercyl;
 
 	/*
 	 * Compute whole disk size. Take max of (pm->dlcyl*pm->dlhead*pm->dlsec)
@@ -101,8 +101,8 @@ md_get_info(void)
 	 * in-core RAW_PART size  value, updating the label will fail.)
 	 */
 	pm->dlsize = pm->dlcyl*pm->dlhead*pm->dlsec;
-	if (pm->disklabel.d_secperunit > pm->dlsize)
-		pm->dlsize = pm->disklabel.d_secperunit;
+	if (disklabel.d_secperunit > pm->dlsize)
+		pm->dlsize = disklabel.d_secperunit;
 
 	return 1;
 }
diff --git a/distrib/utils/sysinst/arch/mvme68k/md.c b/distrib/utils/sysinst/arch/mvme68k/md.c
index 7821f98..4d774ca 100644
--- a/distrib/utils/sysinst/arch/mvme68k/md.c
+++ b/distrib/utils/sysinst/arch/mvme68k/md.c
@@ -64,7 +64,7 @@ md_get_info(void)
 	char buf[1024];
 	int fd;
 	char dev_name[100];
-	struct pm->disklabel pm->disklabel;
+	struct disklabel disklabel;
 
 	snprintf(dev_name, 100, "/dev/r%sc", pm->diskdev);
 
@@ -76,7 +76,7 @@ md_get_info(void)
 		fprintf(stderr, "Can't open %s\n", dev_name);
 		exit(1);
 	}
-	if (ioctl(fd, DIOCGDINFO, &pm->disklabel) == -1) {
+	if (ioctl(fd, DIOCGDINFO, &disklabel) == -1) {
 		if (logfp)
 			(void)fprintf(logfp, "Can't read disklabel on %s.\n",
 				dev_name);
@@ -85,18 +85,18 @@ md_get_info(void)
 		close(fd);
 		exit(1);
 	}
-	if (pm->disklabel.d_secsize != 512) {
+	if (disklabel.d_secsize != 512) {
 		endwin();
 		fprintf(stderr, "Non-512byte/sector disk is not supported.\n");
 		close(fd);
 		exit(1);
 	}
 
-	pm->dlcyl = pm->disklabel.d_ncylinders;
-	pm->dlhead = pm->disklabel.d_ntracks;
-	pm->dlsec = pm->disklabel.d_nsectors;
-	pm->sectorsize = pm->disklabel.d_secsize;
-	pm->dlcylsize = pm->disklabel.d_secpercyl;
+	pm->dlcyl = disklabel.d_ncylinders;
+	pm->dlhead = disklabel.d_ntracks;
+	pm->dlsec = disklabel.d_nsectors;
+	pm->sectorsize = disklabel.d_secsize;
+	pm->dlcylsize = disklabel.d_secpercyl;
 	pm->dlsize = pm->dlcyl*pm->dlhead*pm->dlsec;
 
 	if (read(fd, buf, 1024) < 0) {
@@ -107,7 +107,7 @@ md_get_info(void)
 	}
 
 	/* preserve first cylinder for system. */
-	pm->ptstart = pm->disklabel.d_secpercyl;
+	pm->ptstart = disklabel.d_secpercyl;
 
 	close(fd);
 
